clear;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%SET THESE PARAMETERS
PARAM.Date=20160621;
FLAG.PremSetting_MatchMargins = 1;
    
    %Robustness
    FLAG.UseSwitchingCosts = 0;
    FLAG.AdjustWTPCoeff = 0;
    FLAG.isRemoveBS = 0;
    FLAG.BC10PercentMargin = 0;

PARAM.NumBootstrap = 80;
PARAM.FixedPremMLR = .80;
PARAM.SwitchingCosts = .9;
PARAM.AdjustWTPCoeff = .75;
PARAM.FileSuffix=f_filesuffix(FLAG,PARAM);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load M_DATA_20160523.mat;
load M_DATAHH_20160523.mat;     
load (['M_InitDemand',PARAM.FileSuffix]);
load(['M_EST',PARAM.FileSuffix]);
disp(['Counterfactuals for M_CF',PARAM.FileSuffix]);

UseHospitalSystems=1;
idxboot=1;
        
for idxboot=1:PARAM.NumBootstrap
        fprintf('BOOT #%f ================================ \n', idxboot);  

        %INITIALIZE BOOTSTRAP PRICES AND ESTIMATES
        ESTIMATESUSE = ESTIMATES{idxboot};
        for idxhsa=1:14
            PRICES{idxhsa}.avgamtdrg = DATA{idxhsa}.avgamtdrg_boot{idxboot};
        end;    
        [LHS, RHS] = f_construct_LHSRHS(DATA, DATAEST, PRICES, INSDEMAND, HOSPDEMAND,  DATAEST.premiums, FLAG, PARAM);    
    
    
        %% BEGIN CF COMPUTATIONS
            clear CF;
            FLAG.HospitalSystemRegression = UseHospitalSystems;
            if FLAG.HospitalSystemRegression==1
                MCUSE = ESTIMATESUSE.MC_sys;
                RESIDPREMUSE = ESTIMATESUSE.resid_sys_prem;
                if FLAG.PremSetting_MatchMargins==1
                    RHOUSE = ESTIMATESUSE.rho_sys;
                else
                    RHOUSE = 1;
                end;
            else
                MCUSE = ESTIMATESUSE.MC;
                RESIDPREMUSE = ESTIMATESUSE.resid_prem;
                if FLAG.PremSetting_MatchMargins==1
                    RHOUSE = ESTIMATESUSE.rho;
                else
                    RHOUSE = 1;
                end;
            end;
               
            %% Counterfactuals: (1-3): Remove BC (in all but HSAs 1 + 8); (4-6) Remove Kaiser; 7 is recompute baseline
            CF_ORDER = [7 1 2 3 4 5 6]; %COMPUTE BASELINE FIRST
            CF_idxBaseline = CF_ORDER(1);
                for idxCF = 1:length(CF_ORDER)
                    CFNUM = CF_ORDER(idxCF);
                    fprintf('USE SYS%f', UseHospitalSystems);
                    fprintf('CF #%f ================ \n', CFNUM);  

                    FLAG.isRemoveBS_CF = 0;
                    FLAG.isRemoveBC_CF = 0;
                    FLAG.isRemoveK_CF = 0;
                    if CFNUM<4
                        FLAG.isRemoveBC_CF = 1;
                    else
                        if CFNUM >=4 && CFNUM <=6
                            FLAG.isRemoveK_CF = 1;
                        end;
                    end;

                    if CFNUM==1 || CFNUM == 4
                            CF{CFNUM}.AdjustPremiums=0;
                            CF{CFNUM}.AdjustPrices=1;
                    else
                        if CFNUM==2 || CFNUM==5
                            CF{CFNUM}.AdjustPremiums=1;
                            CF{CFNUM}.AdjustPrices=0;
                        else
                            CF{CFNUM}.AdjustPremiums=1;
                            CF{CFNUM}.AdjustPrices=1;
                        end;
                    end;         

                    if CFNUM~=CF_idxBaseline
                        CF{CFNUM}.INSDEMAND = CF{CF_idxBaseline}.INSDEMAND;
                        CF{CFNUM}.HOSPDEMAND = CF{CF_idxBaseline}.HOSPDEMAND;
                        CF{CFNUM}.premiums = CF{CF_idxBaseline}.premiums;
                        CF{CFNUM}.PRICES = CF{CF_idxBaseline}.PRICES;
                    else
                        CF{CFNUM}.INSDEMAND = INSDEMAND;
                        CF{CFNUM}.HOSPDEMAND = HOSPDEMAND;
                        CF{CFNUM}.premiums = DATAEST.premiums;
                        CF{CFNUM}.PRICES = PRICES;    
                    end;
                        
                    if CFNUM==3 || CFNUM==6
                        CF{CFNUM}.premiums = CF{CFNUM-1}.premiums;      %Use premiums solved for in previous exercise
                    end;
                    temp.err_prems = 10^10;
                    temp.err_prems_outerloop = 10^10;
                    temp.err_demand = 10^10;    
                    temp.iter = 0;

                    while temp.err_demand > 30 && temp.err_prems_outerloop > 1 &&  temp.iter < 25    
                        %[1] Update Insurer Premiums
                        temp.OldPrems = CF{CFNUM}.premiums;
                        temp.err_prems = 10^10;
                        temp.iter_innerprem = 0;
                        while temp.err_prems > .1 && temp.iter_innerprem < 50
                            temp.PredictedInsDemand_Old = zeros(3,14);    
                            for idxhsa=1:14
                              temp.PredictedInsDemand_Old(:,idxhsa)=temp.PredictedInsDemand_Old(:,idxhsa)+sum(CF{CFNUM}.INSDEMAND{idxhsa}.fam(:,:,1),2);
                            end;

                            if temp.iter_innerprem < 10
                                temp.tuning_innerprem = .6;
                            else
                                if temp.iter_innerprem < 20
                                    temp.tuning_innerprem = .4;
                                else
                                    if temp.iter_innerprem < 30
                                        temp.tuning_innerprem = .2;
                                    else
                                        temp.tuning_innerprem = .1;
                                    end;
                                end;
                            end;
                            temp.premiums = CF{CFNUM}.premiums;                
                            if CF{CFNUM}.AdjustPremiums==1

                                [CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND] = f_update_demand_derivelast(CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND, DATA, DATAHH, CF{CFNUM}.premiums, DATAEST.insdemandcoeffs, DATAEST.drgwts, FLAG, PARAM);
                                                             
                                [CF{CFNUM}.premiums fval] = f_cf_updatepremiums_barg_2016(CF{CFNUM}.PRICES, CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND, MCUSE, RHOUSE, RESIDPREMUSE, FLAG, PARAM, CF{CFNUM}.premiums);                                
                                
                                CF{CFNUM}.premiums = (temp.tuning_innerprem)*CF{CFNUM}.premiums + (1-temp.tuning_innerprem) * temp.premiums;
                                for idxins=1:3
                                    if CF{CFNUM}.premiums(idxins,1) > 20000 || CF{CFNUM}.premiums(idxins,1) < 0 || isnan(CF{CFNUM}.premiums(idxins,1))
                                        CF{CFNUM}.premiums(idxins,:) = DATAEST.premiums(idxins,:);
                                    end;
                                end;
                                if FLAG.isRemoveK_CF==1
                                    CF{CFNUM}.premiums(3,:) = 0;
                                end;
                            end;
                            temp.err_prems = max(max(abs(CF{CFNUM}.premiums - temp.premiums)));
                            disp([CF{CFNUM}.premiums(:,1)'/1000 temp.err_prems]);
                            temp.iter_innerprem = temp.iter_innerprem+1;
                            if temp.iter_innerprem < 5
                                temp.err_prems = 100;
                            end;
                        end;
                        %Outerloop Premium Error
                        temp.err_prems_outerloop = max(max(abs(CF{CFNUM}.premiums - temp.OldPrems)));

                        %[2] Update Insurer and Hospital Demand        
                        [CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND] = f_initialize_inshospdemand(DATA,DATAHH, CF{CFNUM}.premiums, DATAEST.insdemandcoeffs, DATAEST.drgwts, FLAG, PARAM);
                            temp.PredictedInsDemand_New = zeros(3,14);    
                            for idxhsa=1:14
                              temp.PredictedInsDemand_New(:,idxhsa)=temp.PredictedInsDemand_New(:,idxhsa)+sum(CF{CFNUM}.INSDEMAND{idxhsa}.fam(:,:,1),2);
                            end;
                        temp.err_demand = max(max(abs(temp.PredictedInsDemand_New-temp.PredictedInsDemand_Old)));

                        %[3] Update Negotiated Prices
                        if CF{CFNUM}.AdjustPrices==1
                            [CF{CFNUM}.PRICES CF{CFNUM}.UpdatedIdx CF{CFNUM}.NewPricesList] =  f_cf_updateprices(DATA,DATAEST, CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND, ESTIMATESUSE, CF{CFNUM}.premiums, FLAG, PARAM);                 
                        end;
                        temp.iter = temp.iter+1;
                        fprintf('Boot %f, CF %f, Iter %f, Prem Error %f, Demand Error %f \n', [idxboot CFNUM temp.iter temp.err_prems temp.err_demand]);  
                        if temp.iter < 3 && (CFNUM~=1 && CFNUM~=4) %run at least twice
                            temp.err_demand = 10^10;
                            temp.err_prems_outerloop = 10^10;
                        end;
                    end;    

                    [CF{CFNUM}.LHS, CF{CFNUM}.RHS] = f_construct_LHSRHS(DATA, DATAEST, CF{CFNUM}.PRICES, CF{CFNUM}.INSDEMAND, CF{CFNUM}.HOSPDEMAND, CF{CFNUM}.premiums, FLAG, PARAM);

                    %CLEAN UP CF STRUCTURE
                    for idxhsa=1:14
                        CF{CFNUM}.INSDEMAND{idxhsa} = rmfield(CF{CFNUM}.INSDEMAND{idxhsa},'insdrop');
                        CF{CFNUM}.INSDEMAND{idxhsa} = rmfield(CF{CFNUM}.INSDEMAND{idxhsa},'zip');
                        CF{CFNUM}.HOSPDEMAND{idxhsa} = rmfield(CF{CFNUM}.HOSPDEMAND{idxhsa},'insdrop');
                    end;            
                end; %for idxCF
                FLAG.isRemoveBC_CF = 0;
                FLAG.isRemoveK_CF = 0;
                FLAG.isRemoveBS_CF = 0;
                

end; %for idxboot