function [premiums_cf fval] = f_cf_updatepremiums_barg_2016(PRICESCF, INSDEMANDCF, HOSPDEMANDCF, MC, tau_phi, resid_prem, FLAG, PARAM, Old_Premiums)

    if nargin<8
        Old_Premiums = [4000; 4000; 4000];
    end;
      
    LBUSE_prem=500*ones(1,3);
    UBUSE_prem=8000*ones(1,3);
    options = optimset('MaxFunEvals', 2000, 'MaxIter', 2000);
     
    newprems_single = Old_Premiums(:,1);
    fval=10^10;
    for repeat=1:2
        for idxins=1:3
            [newprems_single(idxins) fval2] = fminsearch(@(newprems_ins) 10^6*( f_premiumsetting_objective(newprems_ins, Old_Premiums, INSDEMANDCF, HOSPDEMANDCF, PRICESCF, MC, FLAG, PARAM, tau_phi, resid_prem, idxins) ),Old_Premiums(idxins,1),options);
            Old_Premiums(idxins,1) = newprems_single(idxins);
            fval = min(fval,fval2);
        end;
    end;
    
    premiums_cf = repmat(newprems_single,1,3) .* repmat([1 2 2.6],3,1);    
end
    
function [fval] = f_premiumsetting_error_partial(newprems, INSDEMANDCF, HOSPDEMANDCF, PRICESCF, MC, FLAG, PARAM, tau_phi, resid_prem)
    prem_errors = f_premiumsetting_error(newprems, INSDEMANDCF, HOSPDEMANDCF, PRICESCF, MC, FLAG, PARAM, tau_phi, resid_prem);
    fval = prem_errors'*prem_errors;
end

function [fval] = f_premiumsetting_objective(newprems_ins, prems_use, INSDEMANDCF, HOSPDEMANDCF, PRICESCF, MC, FLAG, PARAM, tau_phi, resid_prem, idxins)
    prems_use(idxins,1) = newprems_ins;
    [prem_errors ImpliedMC dPi_dPrem GFT_M GFT_E dGFTE_dPrem] = f_premiumsetting_error(prems_use(:,1), INSDEMANDCF, HOSPDEMANDCF, PRICESCF, MC, FLAG, PARAM, tau_phi, resid_prem);
    fval = - (GFT_M(idxins))^(tau_phi)*(GFT_E(idxins))^(1-tau_phi);
end