function [PRICESCF UpdatedIdx ListUpdatedPrices] = f_cf_updateprices(DATA,DATAEST, INSDEMAND, HOSPDEMAND, ESTIMATES, PremiumsUse, FLAG, PARAM)

    %INITIALIZE CF PRICES TO OLD PRICES
    for idxhsa=1:14
        PRICESCF{idxhsa}.avgamtdrg = DATA{idxhsa}.avgamtdrg;
    end;    

    %LHS_NEW AND RHS_NEW WILL CORRESPOND TO OLD VALUES UNLESS INSURERS ARE REMOVED, AS IN CFS...
    [LHS_NEW, RHS_NEW] = f_construct_LHSRHS(DATA,DATAEST, PRICESCF, INSDEMAND, HOSPDEMAND, PremiumsUse, FLAG, PARAM);
    
    if FLAG.HospitalSystemRegression==0
    %% NON-HOSP SYSTEM BARGAINING
        tau_M = ESTIMATES.tau;
        tau_H = 1-tau_M; 
        MCUSE = ESTIMATES.MC;
        ResidsUSE = ESTIMATES.resid;
        
        %MATRIX INVERSION TO RECOVER PRICES
        % Need to adjust LHS.Matrix to add in Bargaining Parameters
        temp.MatrixUse = LHS_NEW.Matrix;                                %This matrix multiples list of Prices on LHS
        temp.ResidsUse = zeros(length(LHS_NEW.Index),1);                %\Omega^2 Residuals to add to prices before inversion
        for idxentry=1:length(LHS_NEW.Index)
            idxins = LHS_NEW.Index(idxentry,2);
            idxotherins = 2;
            if idxins==2
                idxotherins = 1;
            end;
            temp.bargscalingvector = ones(length(LHS_NEW.Index),1);                                 %Multiplies prices on same insurer by \tau_H, on other insurer by \tau_M; not diagonal:
            temp.bargscalingvector( LHS_NEW.Index(:,2)==idxins, 1) = tau_H(idxins);         %Coefficient on prices on same insurer is \tau_H
            temp.bargscalingvector( LHS_NEW.Index(:,2)==idxotherins, 1) = tau_M(idxins);  %Coefficient on prices on other insurers is \tau_M
            temp.bargscalingvector( idxentry, 1) = 1;                                           %Coefficient on own price = 1
            temp.MatrixUse(idxentry, :) = LHS_NEW.Matrix(idxentry,:) .* temp.bargscalingvector';
            temp.ResidsUse(idxentry) = ResidsUSE(strmatch(LHS_NEW.Index(idxentry,1:3), ESTIMATES.resid_index)); %Find the residual that corresponds to the entry in question... NEED THIS FOR CF's
        end;

        temp.RHSUse = tau_H(LHS_NEW.Index(:,2))' .* (RHS_NEW.InsPremRev - MCUSE(LHS_NEW.Index(:,2)) .* RHS_NEW.InsChangeIndivs) + (tau_M(LHS_NEW.Index(:,2)))' .* (RHS_NEW.HospCostsXDemand + RHS_NEW.HospOtherInsCostsXDemand) + LHS_NEW.HospDemand .* temp.ResidsUse;
        temp.NewPrices = (temp.MatrixUse) \ temp.RHSUse;

    else
    %% HOSP SYSTEM BARGAINING
        tau_M = ESTIMATES.tau_sys;
        tau_H = 1-tau_M;        
        MCUSE = ESTIMATES.MC_sys;
        ResidsUSE = ESTIMATES.resid_sys;
        
        LHS_NEW.Matrix_sys = zeros(length(LHS_NEW.Index),length(LHS_NEW.Index));  %This matrix multiples list of Prices on LHS
        temp.RHSUse_sys = zeros(length(LHS_NEW.Index),1);
        LHS_NEW.Index(:,4) = zeros(length(LHS_NEW.Index),1);
        
        %Generate List of systems for each entry
        for idxentry=1:length(LHS_NEW.Index)
            idxhsa = LHS_NEW.Index(idxentry,1);
            idxins = LHS_NEW.Index(idxentry,2);
            idxhosp = LHS_NEW.Index(idxentry,3);
            LHS_NEW.Index(idxentry,4) = DATA{idxhsa}.listsysid(idxhosp);
        end;
        
        for idxentry=1:length(LHS_NEW.Index)
            idxhsa = LHS_NEW.Index(idxentry,1);
            idxins = LHS_NEW.Index(idxentry,2);
            idxhosp = LHS_NEW.Index(idxentry,3);
            idxsys = LHS_NEW.Index(idxentry,4);
            idxotherins = 2;
            if idxins==2
                idxotherins = 1;
            end;
            
            isonsys = ( (LHS_NEW.Index(:,1)==idxhsa) .* (LHS_NEW.Index(:,2)==idxins) .* (LHS_NEW.Index(:,4)==idxsys));
            hospentries = find(isonsys);            %List of indices for all hospitals in system on this insurer
            
            isonsys_otherins = ( (LHS_NEW.Index(:,1)==idxhsa) .* (LHS_NEW.Index(:,2)==idxotherins) .* (LHS_NEW.Index(:,4)==idxsys));
            hospentries_otherins = find(isonsys_otherins); 
            
            if idxentry == hospentries(1)           %Only proceed if the first hospital in system on insurer
                %Own system prices from this insurer
                for idxsysmembers = 1:(length(hospentries))
                    idxentry2 = hospentries(idxsysmembers);
                    idxhosp2 = LHS_NEW.Index(idxentry2,3);
                    LHS_NEW.Matrix_sys(idxentry,idxentry2) = HOSPDEMAND{idxhsa}.indXdrg(idxhosp2,idxins,1);                    
                end;
                %Recapture Prices from other insurer, same system
                for idxsysmembersotherins = 1:length(hospentries_otherins)
                    idxentry2 = hospentries_otherins(idxsysmembersotherins);
                    idxhosp2 = LHS_NEW.Index(idxentry2,3);
                    LHS_NEW.Matrix_sys(idxentry,idxentry2) = tau_M(idxins) *  (HOSPDEMAND{idxhsa}.indXdrg(idxhosp2,idxotherins,1) - HOSPDEMAND{idxhsa}.insdrop{idxins}.hospdropsys{idxhosp}.indXdrg(idxhosp2,idxotherins,1));
                end;
                %Prices for other hospitals on this insurer (reinforcement)
                isnotonsys = ( (LHS_NEW.Index(:,1)==idxhsa) .* (LHS_NEW.Index(:,2)==idxins) .* (LHS_NEW.Index(:,4)~=idxsys));
                hospentries_notonsys = find(isnotonsys);            %List of indices for all hospitals in system on this insurer
                for idxnotonsys=1:length(hospentries_notonsys) 
                    idxentry2 = hospentries_notonsys(idxnotonsys);
                    idxhosp2 = LHS_NEW.Index(idxentry2,3);                    
                    LHS_NEW.Matrix_sys(idxentry,idxentry2) = tau_H(idxins) * (HOSPDEMAND{idxhsa}.indXdrg(idxhosp2,idxins,1) - HOSPDEMAND{idxhsa}.insdrop{idxins}.hospdropsys{idxhosp}.indXdrg(idxhosp2,idxins,1));
                end;
                %RHS is same as system variables w/o using prices
                temp.idxonsysvars = strmatch( [idxhsa idxins idxsys] , LHS_NEW.Index_sys );
                temp.idx_resid = strmatch( [idxhsa idxins idxsys] , ESTIMATES.resid_sys_index );
                temp.RHSUse_sys(idxentry) = tau_H(idxins) * (RHS_NEW.InsPremRev_sys(temp.idxonsysvars) - MCUSE(LHS_NEW.Index(idxentry,2)) .* RHS_NEW.InsChangeIndivs_sys(temp.idxonsysvars)) ...
                        + (tau_M(idxins)) * (RHS_NEW.HospCostsXDemand_sys(temp.idxonsysvars) + RHS_NEW.HospOtherInsCostXDemand_sys(temp.idxonsysvars)) ...
                        + LHS_NEW.HospDemand_sys(temp.idxonsysvars) * ResidsUSE(temp.idx_resid);
            else %if not the first hospital on a sys, then make its price a fraction of the first hospital price                
                idxhospbase = LHS_NEW.Index(hospentries(1),3); %Hospital Index for First hospital in system on hsa,ins
                temp.fractionofbase = DATA{idxhsa}.avgamtdrg(idxhosp,idxins)/DATA{idxhsa}.avgamtdrg(idxhospbase,idxins);
                LHS_NEW.Matrix_sys(idxentry,idxentry) = 1;                
                LHS_NEW.Matrix_sys(idxentry,hospentries(1)) = -temp.fractionofbase;
            end;                
        end; %for idxentry
        temp.NewPrices = (LHS_NEW.Matrix_sys) \ temp.RHSUse_sys;
    end; %if FLAG.HospitalSystemRegression

    for idxentry=1:length(temp.NewPrices)
        PRICESCF{LHS_NEW.Index(idxentry,1)}.avgamtdrg(LHS_NEW.Index(idxentry,3),LHS_NEW.Index(idxentry,2)) = temp.NewPrices(idxentry); 
    end;

    UpdatedIdx = LHS_NEW.Index;
    ListUpdatedPrices = temp.NewPrices;
