function [dWTP dWTPsys] = f_compute_dWTP(DATA, DATAHH, INSDEMAND)

    %Construct dWTP for each hospital using estimated patient flows
    %from non-premium insurer demand estimates, and average over
    %age-sex-zip WTP differences.
    fprintf('Generating WTP Estimates: ');    
    for idxhsa=1:14
        fprintf('%d ', idxhsa);
        temp.nHospsinHSA = length(DATA{idxhsa}.listhosps);
        dWTP{idxhsa} = zeros(temp.nHospsinHSA,2);
        dWTPsys{idxhsa} = zeros(temp.nHospsinHSA,2);
        for idxhosp=1:temp.nHospsinHSA
            for idxzipHH=1:length(DATAHH{idxhsa}.listzips)
                
                dWTPUSE = (DATA{idxhsa}.zip{idxzipHH}.WTP - DATA{idxhsa}.hospdrop{idxhosp}.zip{idxzipHH}.WTP);
                dWTPUSEsys = (DATA{idxhsa}.zip{idxzipHH}.WTP - DATA{idxhsa}.hospdropsys{idxhosp}.zip{idxzipHH}.WTP);
                for idxins=1:2
                    if DATA{idxhsa}.hosp{idxhosp}.ison(idxins)==0
                        dWTPUSE(:,idxins) = 0;
                        dWTPUSEsys(:,idxins) = 0;
                    end;
                end;
                
                for idxhhtype = 1:3    
                    nhhtype=DATAHH{idxhsa}.zip{idxzipHH}.nhhtype(idxhhtype);
                    if nhhtype>0
                        dWTP{idxhsa}(idxhosp,:) =  dWTP{idxhsa}(idxhosp,:) + sum(INSDEMAND{idxhsa}.zip{idxzipHH}.famshare{idxhhtype}(:,1:2,1) .* (DATAHH{idxhsa}.zip{idxzipHH}.hhtype{idxhhtype}.members(:,:) * dWTPUSE));
                        dWTPsys{idxhsa}(idxhosp,:) = dWTPsys{idxhsa}(idxhosp,:) + sum(INSDEMAND{idxhsa}.zip{idxzipHH}.famshare{idxhhtype}(:,1:2,1) .* (DATAHH{idxhsa}.zip{idxzipHH}.hhtype{idxhhtype}.members(:,:) * dWTPUSEsys));
                    end;
                end;
            end;
        end;
    end;
    fprintf('Done.\n');
