//Calculation of WTP variable using method from Ho (2006)

*=====================================
global dir_root 	/home/HC

global dir_raw 		$dir_root/d01.RawData
global dir_log 		$dir_root/d02.Scripts.and.Logs
global dir_intout 	$dir_root/d03.Intermediate.Output
global dir_out 		$dir_root/d04.Cleaned.Output
global dir_temp 	$dir_root/d99.Temp

clear
set more off
cap log close
*=====================================

log using "$dir_log/Logs/WTPcalcn_Part3_20160523.log", text replace

set type double


	*************************
	* PART 3 
	*************************			
	*=========================
	* Create WTP variable for each insurer (the HMO)
	*=========================
	foreach insurer in BS BC {
		use  "$dir_intout/WTPcalc/WTP_data20160523_6hsa_`insurer'_sys.dta", clear
	
		bys zipcode03 sex agecat_Ho: gen numchoice = [_n]	
		keep if numchoice==1
		drop numchoice
		keep EU_ijl* p_* zipcode03 hsa hrrnum agecat_Ho sex
				
		gen WTP_ij = 0		
		local diags "cancer cardiac digestive labor neuro othercode"
		foreach x of local diags  {
			replace WTP_ij = WTP_ij + EU_ijl_`x'*p_`x'
			
		} 
						
		gen gamma_WTP_ij = p_adm * WTP_ij


	gen insurer="`insurer'"
		save "$dir_intout/WTPcalc/WTP_`insurer'_noD_20160523.dta", replace
	}
	*** end(for insurer in BS BC)
	*=========================
	
	
	
	u "$dir_intout/WTPcalc/WTP_BS_noD_20160523.dta", clear
	append using "$dir_intout/WTPcalc/WTP_BC_noD_20160523.dta"

		
	la data "Zip-Age-Sex-Insurer WTP from obs network(create_4_WTPcalcn_Part3_noD.do) created `c(current_date)'"
	save "$dir_intout/WTPcalc/WTP_20160523.dta", replace	
	des
	bys insurer: sum WTP*, detail
	bys insurer: sum gamma_WTP*, detail
				
				
	log close
			
		
