*Outsheet variables needed to estimate bargaining equation. Created in create_6_matlabvbles 

clear 

*=====================================
global dir_root     /home/HC
global dir_raw 		$dir_root/d01.RawData
global dir_log 		$dir_root/d02.Scripts.and.Logs
global dir_intout 	$dir_root/d03.Intermediate.Output
global dir_out 		$dir_root/d04.Cleaned.Output
global dir_temp 	$dir_root/d99.Temp

clear
set more off
cap log close
*=====================================

log using "$dir_log/variable_outsheet_20160523.log", text replace		
set type double


*=========================
* Outsheet sigmaH for each insurer-hospital pair
*=========================
use "$dir_intout/sigmaH_20160523.dta", clear		
des
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"


keep hsa zipcode03 agecat_Ho sex  oshpdid insurer sigmaH_kijm
order hsa zipcode03 agecat_Ho sex  oshpdid insurer sigmaH_kijm
sort hsa insurer zipcode03 agecat_Ho sex oshpdid

outsheet using "$dir_intout/sigmaH_kijm_20160523.csv", comma nonames nolabel noquote replace		
*================================================================================	


*=========================
* Outsheet sigmaH_kijm_drophosp for each insurer-hospital pair x every hospital that could be dropped.
*=========================

use "$dir_intout/sigmaH_drop2_20160523.dta", clear			
des
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"

keep hsa zipcode03 agecat_Ho sex oshpdid insurer oshpdid_drop sigmaH_kijm_drop
order hsa zipcode03 agecat_Ho sex oshpdid insurer oshpdid_drop sigmaH_kijm_drop
sort hsa insurer zipcode03 agecat_Ho sex oshpdid oshpdid_drop


outsheet using "$dir_intout/sigmaH_kijm_drop_20160523.csv", comma nonames nolabel noquote replace		


*=========================
* Outsheet sigmaH_kijm_drop_sys for each insurer-hospital pair x every hospital that could be dropped.
*=========================


use "$dir_intout/sigmaH_drop2_20160523.dta", clear			
des
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"

keep hsa zipcode03 agecat_Ho sex oshpdid insurer oshpdid_drop sigmaH_kijm_drop_sys
order hsa zipcode03 agecat_Ho sex oshpdid insurer oshpdid_drop sigmaH_kijm_drop_sys
sort hsa insurer zipcode03 agecat_Ho sex oshpdid oshpdid_drop

outsheet using "$dir_intout/sigmaH_kijm_drop_sys_20160523.csv", comma nonames nolabel noquote replace		


*================================
*Outsheet WTP_kjm for each insurer-zip-age-sex
*==================================
use "$dir_intout/WTPcalc/WTP_20160523.dta", clear			
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"
keep hsa zipcode03 agecat_Ho sex insurer gamma_WTP_ij
order hsa zipcode03 agecat_Ho sex insurer gamma_WTP_ij
sort hsa insurer zipcode03 agecat_Ho sex
outsheet using "$dir_intout/WTP_kjm_20160523.csv", comma nonames nolabel noquote replace		
*=======================================
*Outsheet Kaiser availability in each zipcode
*=======================================
merge m:1 zipcode03 using "$dir_temp/insdemand_KaiserDistance.dta"			
drop if _merge==2
drop _merge
outsheet using "$dir_intout/WTP_and_KaiserDistance_20160523.csv", comma nonames nolabel noquote replace


*=================================
*Outsheet WTP_kjm_drop for each insurer-zip-age-sex and each oshpdid_drop
*===================================
use "$dir_intout/WTP_drop_20160523.dta", clear				
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"

keep hsa zipcode03 agecat_Ho sex insurer oshpdid_drop gamma_WTP_kjm_drop
order hsa zipcode03 agecat_Ho sex insurer oshpdid_drop gamma_WTP_kjm_drop
sort hsa insurer zipcode03 agecat_Ho sex oshpdid_drop

outsheet using "$dir_intout/WTP_kjm_drop_20160523.csv", comma nonames nolabel noquote replace		


*======================================
*Outsheet WTP_kjm_drop_sys for each insurer-zip-age-sex and each hospital's system being dropped
*=======================================

use "$dir_intout/WTP_drop_20160523.dta", clear			
ren insurer insurername
gen insurer=1
replace insurer=2 if insurername=="BC"

keep hsa zipcode03 agecat_Ho sex insurer oshpdid_drop gamma_WTP_kjm_drop_sys
order hsa zipcode03 agecat_Ho sex insurer oshpdid_drop gamma_WTP_kjm_drop_sys
sort hsa insurer zipcode03 agecat_Ho sex oshpdid_drop

outsheet using "$dir_intout/WTP_kjm_drop_sys_20160523.csv", comma nonames nolabel noquote replace		



*======================================
*Outsheet Hospital Characteristics
*=======================================
* create_1_hospcharas_20150303.do
*=======================================
use "$dir_intout/WTPcalc/hospital_charas5_20160523.dta", clear			
keep hsa oshpdid sysid avg_drgwt avg_amt_drgadj_BS avg_amt_drgadj_BC nAdmits_BS nAdmits_BC avg_drgwt_BS avg_drgwt_BC exp_peradm pay_peradm exp_dly_pa isBS isBC FP med_amt_allowed_BS med_amt_allowed_BC BS_boot* BC_boot*
order hsa oshpdid sysid avg_drgwt avg_amt_drgadj_BS avg_amt_drgadj_BC nAdmits_BS nAdmits_BC avg_drgwt_BS avg_drgwt_BC exp_peradm pay_peradm exp_dly_pa isBS isBC FP med_amt_allowed_BS med_amt_allowed_BC BS_boot* BC_boot*
so hsa oshpdid
outsheet using "$dir_intout/hospchars_20160523.csv", comma nonames nolabel noquote replace			
	
*======================================
*Outsheet Hospital Utilities and Probs
*=======================================
u  "$dir_intout/WTPcalc/WTP_data20160523_5hsa.dta", replace			
keep hsa oshpdid agecat_Ho sex zipcode03 u_ihl_*
order hsa oshpdid agecat_Ho sex zipcode03 u_ihl_cancerBS u_ihl_cardiacBS u_ihl_digestiveBS u_ihl_laborBS u_ihl_neuroBS u_ihl_othercodeBS u_ihl_cancerBC u_ihl_cardiacBC u_ihl_digestiveBC u_ihl_laborBC u_ihl_neuroBC u_ihl_othercodeBC
so hsa oshpdid agecat_Ho sex zipcode03 
outsheet using "$dir_intout/hosputils_20160523.csv", comma nonames nolabel noquote replace			

u  "$dir_intout/WTPcalc/WTP_data20160523_5hsa.dta", replace			
duplicates drop agecat_Ho sex, force
keep agecat_Ho sex p_adm p_cancer p_cardiac p_digestive p_labor p_neurological p_othercode
order agecat_Ho sex p_adm p_cancer p_cardiac p_digestive p_labor p_neurological p_othercode 
so agecat_Ho sex p_adm p_cancer p_cardiac p_digestive p_labor p_neurological p_othercode 
outsheet using "$dir_intout/probadmit_20160523.csv", comma nonames nolabel noquote replace			


*======================================
*Outsheet Households
*=======================================
u "$dir_intout/insdemand_enrollment_20160523.dta", replace			
egen familyid = group(fid)
bys familyid: gen personid = _n
keep hsa zipcode03 party_rollup agecat_Ho sex relationship planchoice familyid personid pay_amount
order hsa zipcode03 party_rollup agecat_Ho sex relationship planchoice familyid personid pay_amount
so hsa zipcode03 party_rollup familyid relationship agecat_Ho sex planchoice personid pay_amount
outsheet using "$dir_intout/households_20160523.csv", comma nonames nolabel noquote replace		

*========================================
*Outsheet HSA-insurer fixed effects from insurer demand
*=========================================
u "$dir_intout/insurer_demand_deltas_20160523.dta", replace			

keep hsa id_insurer delta
order hsa id_insurer delta
sort hsa id_insurer
outsheet using "$dir_intout/insurer_demand_deltas_20160523.csv", comma nonames nolabel noquote replace		

u "$dir_intout/insurer_demand_coeffs_20160523.dta", replace			
keep hsa party_rollup sex agecat_Ho WTPcoeff Pricecoeff LogIncPricecoeff  Kcoeff K2coeff
order hsa party_rollup sex agecat_Ho WTPcoeff Pricecoeff LogIncPricecoeff  Kcoeff K2coeff
sort hsa party_rollup sex agecat_Ho WTPcoeff Pricecoeff LogIncPricecoeff  Kcoeff K2coeff
outsheet using "$dir_intout/insurer_demand_coeffs_20160523.csv", comma nonames nolabel noquote replace		

log close
